package com.ruoyi.web.v3.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.web.v3.entity.HbReleaseRecordEntity;
import com.ruoyi.web.v3.mapper.HbReleaseRecordMapper;
import com.ruoyi.web.v3.model.request.HbReleaseRecordPageReq;
import com.ruoyi.web.v3.service.IHbReleaseRecordService;
import com.ruoyi.web.v3.utils.QueryWrapperBuildUtil;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import java.util.Arrays;

import static com.ruoyi.common.core.domain.AjaxResult.error;
import static com.ruoyi.common.core.domain.AjaxResult.success;

/**
 * <p>
 * v3.0 出厂情况登记 服务实现类
 * </p>
 *
 */
@Service
public class HbReleaseRecordServiceImpl extends ServiceImpl<HbReleaseRecordMapper, HbReleaseRecordEntity> implements IHbReleaseRecordService {

    @Transactional
    @Override
    public AjaxResult add(HbReleaseRecordEntity request) {
        //入参检测
        if(ObjectUtils.isEmpty(request.getRecordTime())) {
            return error("请输入【日期时间】！");
        }
        //防重检测，
        Integer count = lambdaQuery().eq(HbReleaseRecordEntity::getMeatQualityCertNo, request.getMeatQualityCertNo()).count();
        if (count != 0) {
            return error("请勿重复添加！");
        }
        return success("添加成功", baseMapper.insert(request));
    }

    @Transactional
    @Override
    public AjaxResult edit(HbReleaseRecordEntity request) {
        //数据格式校验
        if(ObjectUtils.isEmpty(request.getId())){
            return error("待更新数据未传入有效ID，请设置数据的唯一标识ID！");
        }
        //根据数据的id更新所有不为空的字段
        return updateById(request) ? success("修改成功！") : error("修改失败，请重试！");
    }

    @Transactional
    @Override
    public AjaxResult delete(String ids) {
        String[] idList = ids.split(",");
        return success("删除成功", removeByIds(Arrays.asList(idList)));
    }

    @Override
    public AjaxResult page(HbReleaseRecordPageReq request) {
        //将请求报文转为实体类
        HbReleaseRecordEntity entity = BeanUtil.toBean(request, HbReleaseRecordEntity.class);
        //构造查询条件（检索条件未定时，先按不为空的字段进行等值查询）
        QueryWrapper<HbReleaseRecordEntity> wrapper = QueryWrapperBuildUtil.notNoneEqWrapperHelper(entity);
        //数据按id降序排列
        wrapper.lambda().orderByDesc(HbReleaseRecordEntity::getId);
        return success(baseMapper.selectPage(request.toPage(), wrapper));
    }

    @Override
    public AjaxResult listAll() {
        return success(lambdaQuery().orderByDesc(HbReleaseRecordEntity::getId).list());
    }
}
